<template>
  <section class="acList">
    <ai-list>
      <ai-title slot="title" title="低代码生成平台" isShowBottomBorder/>
      <template #content>
        <ai-search-bar>
          <template #left>
            <el-button type="primary" icon="iconfont iconAdd" @click="handleAdd()">添加</el-button>
          </template>
          <template #right>
            <el-input size="small" placeholder="搜索应用" v-model="search.name" clearable
                      @change="page.current=1,getTableData()"/>
          </template>
        </ai-search-bar>
        <ai-table :tableData="tableData" :total="page.total" :current.sync="page.current" :size.sync="page.size"
                  @getList="getTableData" :col-configs="colConfigs" :dict="dict">
          <el-table-column slot="options" label="操作" fixed="right" align="center" width="300">
            <template slot-scope="{row}">
              <el-button type="text" @click="handleAdd(row.id)">编辑</el-button>
              <el-button type="text" @click="handleDelete(row.id)">删除</el-button>
              <el-button type="text" @click="top.handleGetCode(row.id)">下载</el-button>
            </template>
          </el-table-column>
        </ai-table>
      </template>
    </ai-list>
  </section>
</template>

<script>
export default {
  name: "acList",
  props: {
    instance: Function,
    dict: Object,
    permissions: Function
  },
  inject: {
    top: {}
  },
  data() {
    return {
      search: {name: ""},
      page: {current: 1, size: 10, total: 0},
      tableData: [],
      colConfigs: [
        {label: "应用名称", prop: "name", width: 200},
        {label: "应用模块", prop: "appName"},
        {label: "权限码", prop: "rightCode"},
        {label: "详情展示方式", prop: "detailType", dict: "detailType"},
      ],
    }
  },
  methods: {
    getTableData() {
      this.instance.post("/node/aicode/list", null, {
        params: {...this.page, ...this.search}
      }).then(res => {
        if (res?.data) {
          this.tableData = res.data.records
          this.page.total = res.data.total
        }
      })
    },
    handleAdd(id) {
      this.$router.push({hash: "#add", query: {id}})
    },
    handleDelete(ids) {
      this.$confirm("是否要删除该应用?").then(() => {
        this.instance.post("/node/aicode/delete", null, {
          params: {ids}
        }).then(res => {
          if (res?.code == 0) {
            this.$message.success("删除成功")
            this.getTableData()
          }
        })
      }).catch(() => 0)
    }
  },
  created() {
    this.getTableData()
  }
}
</script>

<style lang="scss" scoped>
.acList {
}
</style>
